
; ** 13-Oct-09 NEHolt - http://n8consultants.com
(defun c:zh ( / hdl xy enttype ed en xy2)
 ; ZOOM to entity "handle". Does not check model vs layout space.
 (while (/= (setq hdl (getstring (strcat
 "\nHandle " (if en "(or I=Zoom IN, O=Zoom out)" "") " ="))) "")
 (cond
 ((= (strcase hdl) "I")(command "_.ZOOM" "1.5x"))
 ((= (strcase hdl) "O")(command "_.ZOOM" "0.75x"))
 (T
 (if (setq en (handent hdl)) ; convert handle string to its "entity name"
 (progn ; appears to be a valid handle number
 (if (setq ed (entget en)) ; open up the entity
 (progn ; success, okay to continue
 (setq xy nil)
 (setq enttype (cdr (assoc 0 ed))) ; extract the entity type
 (princ "\nEntity type: ")(princ enttype)
 (if (= enttype "INSERT")
 (progn ; this is a block INSERT instance
 (princ " blk nam=")
 (princ (cdr (assoc 2 ed))) ; display block name
 ) )
 ; Figure where entity is located
 (if (cdr (assoc 10 ed))
 (progn
 (setq xy (cdr (assoc 10 ed))) ; 10 subrec often gives a location value
 (if (= enttype "LINE")
 (progn ; LINE entity. Reset to zoom to line's midpoint
 (setq xy2 (cdr (assoc 11 ed))) ; XY of other end
 ; Calc midpoint coordinate
 (setq xy (list (+ (car xy) (* 0.5 (- (car xy2) (car xy))))
 (+ (cadr xy) (* 0.5 (- (cadr xy2) (cadr xy))))
 (+ (caddr xy) (* 0.5 (- (caddr xy2) (caddr xy))))))
 ) ) ) )
 (if xy
 (progn ; Non-blank XY extracted from picked entity. Go ahead and
 ; display the value and ZOOM in to that point on the drawing.
 (princ " XY=")(princ xy)
 (command "_.ZOOM" "_C" xy 1.0) ; use ZOOM CENTER command
 (redraw en 3) ; trigger entity to "highlight"
 ) )
 ) ) ) )
 )
 )
 )
 (command "_.REGEN") ; brute force - unhighlight everything
 (princ) ; quiet return
)